<html>
<head>
<title>OgreGLSLLinkProgram.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_5bc5f2f46c6364f2594540d45df3d051.html">GL</a>      </li>
      <li class="navelem"><a class="el" href="dir_4557aaee8cf510d5b035fe0c2c5dd433.html">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_81e02400f093837e2a11409f96e5fd4f.html">GLSL</a>      </li>
      <li class="navelem"><a class="el" href="dir_2fa9b21d57931d849b3ca4a2f6225bef.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLSLLinkProgram.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLSLLinkProgram_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __GLSLLinkProgram_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __GLSLLinkProgram_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLPrerequisites_8h.html">OgreGLPrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreGpuProgram_8h.html">OgreGpuProgram.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareVertexBuffer_8h.html">OgreHardwareVertexBuffer.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00037"></a><a class="code" href="structOgre_1_1GLUniformReference.html">00037</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1GLUniformReference.html" title="Structure used to keep track of named uniforms in the linked program object.">GLUniformReference</a>
<a name="l00038"></a>00038     {
<a name="l00040"></a><a class="code" href="structOgre_1_1GLUniformReference.html#a40c3bd9bb06deeb80a6f3797649a5335">00040</a>         GLint  <a class="code" href="structOgre_1_1GLUniformReference.html#a40c3bd9bb06deeb80a6f3797649a5335" title="GL location handle.">mLocation</a>;
<a name="l00042"></a><a class="code" href="structOgre_1_1GLUniformReference.html#a2d32db8791ed30e82ae3a73485ab0085">00042</a>         <a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> <a class="code" href="structOgre_1_1GLUniformReference.html#a2d32db8791ed30e82ae3a73485ab0085" title="Which type of program params will this value come from?">mSourceProgType</a>;
<a name="l00044"></a><a class="code" href="structOgre_1_1GLUniformReference.html#af895033109bbba669cdaa19710aca90b">00044</a>         <span class="keyword">const</span> <a class="code" href="structOgre_1_1GpuConstantDefinition.html" title="Information about predefined program constants.">GpuConstantDefinition</a>* <a class="code" href="structOgre_1_1GLUniformReference.html#af895033109bbba669cdaa19710aca90b" title="The constant definition it relates to.">mConstantDef</a>;
<a name="l00045"></a>00045     };
<a name="l00046"></a>00046 
<a name="l00047"></a><a class="code" href="namespaceOgre.html#a24aca8d208dcf62fbe3bee9e759ac73d">00047</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;GLUniformReference&gt;::type</a> <a class="code" href="namespaceOgre.html#a24aca8d208dcf62fbe3bee9e759ac73d">GLUniformReferenceList</a>;
<a name="l00048"></a><a class="code" href="namespaceOgre.html#a644f74bf84779c83312a97e169164d07">00048</a>     <span class="keyword">typedef</span> GLUniformReferenceList::iterator <a class="code" href="namespaceOgre.html#a644f74bf84779c83312a97e169164d07">GLUniformReferenceIterator</a>;
<a name="l00049"></a>00049 
<a name="l00054"></a><a class="code" href="classOgre_1_1GLSLLinkProgram.html">00054</a>     <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLSLLinkProgram.html" title="C++ encapsulation of GLSL Program Object.">GLSLLinkProgram</a>
<a name="l00055"></a>00055     {
<a name="l00056"></a>00056     <span class="keyword">private</span>:
<a name="l00058"></a><a class="code" href="classOgre_1_1GLSLLinkProgram.html#a549ee67a98b3c3a6c8999bdabad16f61">00058</a>         <a class="code" href="namespaceOgre.html#a24aca8d208dcf62fbe3bee9e759ac73d">GLUniformReferenceList</a> <a class="code" href="classOgre_1_1GLSLLinkProgram.html#a549ee67a98b3c3a6c8999bdabad16f61" title="Container of uniform references that are active in the program object.">mGLUniformReferences</a>;
<a name="l00059"></a>00059 
<a name="l00061"></a><a class="code" href="classOgre_1_1GLSLLinkProgram.html#a2d6db186b5302e1561450dccdcb22350">00061</a>         <a class="code" href="classOgre_1_1GLSLGpuProgram.html" title="GLSL low level compiled shader object - this class is used to get at the linked program object and pr...">GLSLGpuProgram</a>* <a class="code" href="classOgre_1_1GLSLLinkProgram.html#a2d6db186b5302e1561450dccdcb22350" title="Linked vertex program.">mVertexProgram</a>;
<a name="l00063"></a><a class="code" href="classOgre_1_1GLSLLinkProgram.html#afc847c4dd2068e452f43e6fea572d84f">00063</a>         <a class="code" href="classOgre_1_1GLSLGpuProgram.html" title="GLSL low level compiled shader object - this class is used to get at the linked program object and pr...">GLSLGpuProgram</a>* <a class="code" href="classOgre_1_1GLSLLinkProgram.html#afc847c4dd2068e452f43e6fea572d84f" title="Linked geometry program.">mGeometryProgram</a>;
<a name="l00065"></a><a class="code" href="classOgre_1_1GLSLLinkProgram.html#a978aae098f94f94ad490219c2085b61b">00065</a>         <a class="code" href="classOgre_1_1GLSLGpuProgram.html" title="GLSL low level compiled shader object - this class is used to get at the linked program object and pr...">GLSLGpuProgram</a>* <a class="code" href="classOgre_1_1GLSLLinkProgram.html#a978aae098f94f94ad490219c2085b61b" title="Linked fragment program.">mFragmentProgram</a>;
<a name="l00066"></a>00066 
<a name="l00068"></a><a class="code" href="classOgre_1_1GLSLLinkProgram.html#a2a9513f443f6ae78e28c65f8a8cc0f84">00068</a>         <span class="keywordtype">bool</span>        <a class="code" href="classOgre_1_1GLSLLinkProgram.html#a2a9513f443f6ae78e28c65f8a8cc0f84" title="Flag to indicate that uniform references have already been built.">mUniformRefsBuilt</a>;
<a name="l00070"></a><a class="code" href="classOgre_1_1GLSLLinkProgram.html#ab483d81a44b9051a5c9d83c176520b63">00070</a>         GLhandleARB <a class="code" href="classOgre_1_1GLSLLinkProgram.html#ab483d81a44b9051a5c9d83c176520b63" title="GL handle for the program object.">mGLHandle</a>;
<a name="l00072"></a><a class="code" href="classOgre_1_1GLSLLinkProgram.html#a2314e0307beae449cff5e5b5fab4509a">00072</a>         GLint       <a class="code" href="classOgre_1_1GLSLLinkProgram.html#a2314e0307beae449cff5e5b5fab4509a" title="Flag indicating that the program object has been successfully linked.">mLinked</a>;
<a name="l00074"></a><a class="code" href="classOgre_1_1GLSLLinkProgram.html#a3f2d3fb9e98153f5e744a947f2401d9d">00074</a>         <span class="keywordtype">bool</span>        <a class="code" href="classOgre_1_1GLSLLinkProgram.html#a3f2d3fb9e98153f5e744a947f2401d9d" title="Flag indicating that the program object has tried to link and failed.">mTriedToLinkAndFailed</a>;
<a name="l00076"></a><a class="code" href="classOgre_1_1GLSLLinkProgram.html#a02712c3b8c1a2ea238e37282d1cd85be">00076</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GLSLLinkProgram.html#a02712c3b8c1a2ea238e37282d1cd85be" title="Flag indicating skeletal animation is being performed.">mSkeletalAnimation</a>;
<a name="l00077"></a>00077 
<a name="l00079"></a>00079         <span class="keywordtype">void</span> buildGLUniformReferences(<span class="keywordtype">void</span>);
<a name="l00081"></a>00081         <span class="keywordtype">void</span> extractAttributes(<span class="keywordtype">void</span>);
<a name="l00082"></a>00082 
<a name="l00083"></a><a class="code" href="classOgre_1_1GLSLLinkProgram.html#af4a7fe6fb05fdf7318672a4d8a283b53">00083</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1set.html">set&lt;GLuint&gt;::type</a> <a class="code" href="classOgre_1_1GLSLLinkProgram.html#af4a7fe6fb05fdf7318672a4d8a283b53">AttributeSet</a>;
<a name="l00085"></a><a class="code" href="classOgre_1_1GLSLLinkProgram.html#a2471b7821b377c0ddebe4aee3ed58df9">00085</a>         <a class="code" href="classOgre_1_1GLSLLinkProgram.html#af4a7fe6fb05fdf7318672a4d8a283b53">AttributeSet</a> <a class="code" href="classOgre_1_1GLSLLinkProgram.html#a2471b7821b377c0ddebe4aee3ed58df9" title="Custom attribute bindings.">mValidAttributes</a>;
<a name="l00086"></a>00086 
<a name="l00088"></a><a class="code" href="structOgre_1_1GLSLLinkProgram_1_1CustomAttribute.html">00088</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1GLSLLinkProgram_1_1CustomAttribute.html" title="Name / attribute list.">CustomAttribute</a>
<a name="l00089"></a>00089         {
<a name="l00090"></a><a class="code" href="structOgre_1_1GLSLLinkProgram_1_1CustomAttribute.html#af074c365e8a86d9b3759816f029b5fc5">00090</a>             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1GLSLLinkProgram_1_1CustomAttribute.html#af074c365e8a86d9b3759816f029b5fc5">name</a>;
<a name="l00091"></a><a class="code" href="structOgre_1_1GLSLLinkProgram_1_1CustomAttribute.html#a8398d3bead7d95abfaf7e0c095735d7a">00091</a>             GLuint <a class="code" href="structOgre_1_1GLSLLinkProgram_1_1CustomAttribute.html#a8398d3bead7d95abfaf7e0c095735d7a">attrib</a>;
<a name="l00092"></a><a class="code" href="structOgre_1_1GLSLLinkProgram_1_1CustomAttribute.html#a452e3182449dd2b8fe437460a4a6dca9">00092</a>             <a class="code" href="structOgre_1_1GLSLLinkProgram_1_1CustomAttribute.html" title="Name / attribute list.">CustomAttribute</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; _name, GLuint _attrib)
<a name="l00093"></a>00093                 :name(_name), attrib(_attrib) {}
<a name="l00094"></a>00094         };
<a name="l00095"></a>00095 
<a name="l00096"></a><a class="code" href="classOgre_1_1GLSLLinkProgram.html#a482f80d83306a6948ec8193b6cc96070">00096</a>         <span class="keyword">static</span> <a class="code" href="structOgre_1_1GLSLLinkProgram_1_1CustomAttribute.html" title="Name / attribute list.">CustomAttribute</a> msCustomAttributes[];
<a name="l00097"></a>00097 
<a name="l00098"></a>00098         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> getCombinedName();       
<a name="l00100"></a>00100         <span class="keywordtype">void</span> compileAndLink();
<a name="l00102"></a>00102         <span class="keywordtype">void</span> getMicrocodeFromCache();
<a name="l00103"></a>00103     <span class="keyword">public</span>:
<a name="l00105"></a>00105         <a class="code" href="classOgre_1_1GLSLLinkProgram.html" title="C++ encapsulation of GLSL Program Object.">GLSLLinkProgram</a>(<a class="code" href="classOgre_1_1GLSLGpuProgram.html" title="GLSL low level compiled shader object - this class is used to get at the linked program object and pr...">GLSLGpuProgram</a>* vertexProgram, <a class="code" href="classOgre_1_1GLSLGpuProgram.html" title="GLSL low level compiled shader object - this class is used to get at the linked program object and pr...">GLSLGpuProgram</a>* geometryProgram, <a class="code" href="classOgre_1_1GLSLGpuProgram.html" title="GLSL low level compiled shader object - this class is used to get at the linked program object and pr...">GLSLGpuProgram</a>* fragmentProgram);
<a name="l00106"></a>00106         ~<a class="code" href="classOgre_1_1GLSLLinkProgram.html" title="C++ encapsulation of GLSL Program Object.">GLSLLinkProgram</a>(<span class="keywordtype">void</span>);
<a name="l00107"></a>00107 
<a name="l00111"></a>00111         <span class="keywordtype">void</span> activate(<span class="keywordtype">void</span>);
<a name="l00112"></a>00112 
<a name="l00116"></a>00116         <span class="keywordtype">void</span> updateUniforms(<a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> params, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> mask, <a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> fromProgType);
<a name="l00120"></a>00120         <span class="keywordtype">void</span> updatePassIterationUniforms(<a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> params);
<a name="l00122"></a><a class="code" href="classOgre_1_1GLSLLinkProgram.html#a435f2d07dbd7ac8949b17abe4e33503b">00122</a>         GLhandleARB <a class="code" href="classOgre_1_1GLSLLinkProgram.html#a435f2d07dbd7ac8949b17abe4e33503b" title="Get the GL Handle for the program object.">getGLHandle</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mGLHandle; }
<a name="l00129"></a><a class="code" href="classOgre_1_1GLSLLinkProgram.html#abf3544f8843e7f45482605c924d41b54">00129</a>         <span class="keywordtype">void</span> setSkeletalAnimationIncluded(<span class="keywordtype">bool</span> included) 
<a name="l00130"></a>00130         { mSkeletalAnimation = included; }
<a name="l00131"></a>00131 
<a name="l00138"></a><a class="code" href="classOgre_1_1GLSLLinkProgram.html#a2187cd91fb668ea0ded423b795a74edb">00138</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GLSLLinkProgram.html#a2187cd91fb668ea0ded423b795a74edb" title="Returns whether the linked program includes the required instructions to perform skeletal animation...">isSkeletalAnimationIncluded</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSkeletalAnimation; }
<a name="l00139"></a>00139 
<a name="l00141"></a>00141         GLuint getAttributeIndex(<a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> semantic, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> index);
<a name="l00143"></a>00143         <span class="keywordtype">bool</span> isAttributeValid(<a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> semantic, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> index);
<a name="l00144"></a>00144 
<a name="l00145"></a>00145     };
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 }
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 <span class="preprocessor">#endif // __GLSLLinkProgram_H__</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
